
#include "plugin_textsaver.h"

#include <stdio.h>
#include <khtml_part.h>
#include <kaction.h>
#include <kinstance.h>
#include <kmessagebox.h>
#include <klocale.h>
#include <kglobal.h>
#include <kfiledialog.h>
#include <qcstring.h>

Plugintextsaver::Plugintextsaver( QObject* parent, const char* name )
    : Plugin( parent, name )
{
    // Instantiate all of your actions here.  These will appear in
    // Konqueror's menu and toolbars.
    (void) new KAction( i18n("Save as &Text"), "textsaver", 0,
                        this, SLOT(slotAction()),
                        actionCollection(), "plugin_action" );
}

Plugintextsaver::~Plugintextsaver()
{
}

void Plugintextsaver::slotAction()
{
    // This plugin assumes KHTMLPart.  If your plugin can handle more
    // than this or a different Part than this, simply delete or
    // change the following block.
   if ( !parent()->inherits("KHTMLPart") )
    {
        QString title( i18n("HTML Only"));
        QString text(i18n("Only HTML documents can be saved with this plugin."));
        KMessageBox::sorry( 0, text, title );
        return;
    }

    // Get a handle on our parent so we may get the necessary data for
    // processing
    KHTMLPart *part = dynamic_cast<KHTMLPart *>(parent());
    QString FN = KFileDialog::getSaveFileName("", "", 0, "Save Text File As");
    if (FN == "") return;
    QString Cmd = "html2text > " + FN;
    QCString Text = part->documentSource().local8Bit();
    FILE * F = popen(Cmd.ascii(), "w");
    fwrite((char*) Text.data(), 1, Text.length(), F);
    pclose(F);
}

textsaverFactory::textsaverFactory()
  : KParts::Factory()
{
}

textsaverFactory::~textsaverFactory()
{
  delete s_instance;
  s_instance = 0;
}

QObject* textsaverFactory::createObject( QObject* parent, const char* name, const char*, const QStringList & )
{
  return new Plugintextsaver( parent, name );
}

KInstance *textsaverFactory::instance()
{
  if ( !s_instance )
    s_instance = new KInstance( "textsaver" );
  return s_instance;
}

extern "C"
{
  void* init_libtextsaverplugin()
  {
    KGlobal::locale()->insertCatalogue("textsaver");
    return new textsaverFactory;
  }
}

KInstance* textsaverFactory::s_instance = 0L;

#include "plugin_textsaver.moc"
